#==============================================================================#
#                        Copyright 2022-2024 ArchaicSoft                       #
#                                                                              #
# Boost Software License - Version 1.0 - August 17th, 2003                     #
#                                                                              #
# Permission is hereby granted, free of charge, to any person or organization  #
# obtaining a copy of the software and accompanying documentation covered by   #
# this license (the "Software") to use, reproduce, display, distribute,        #
# execute, and transmit the Software, and to prepare derivative works of the   #
# Software, and to permit third-parties to whom the Software is furnished to   #
# do so, all subject to the following:                                         #
#                                                                              #
# The copyright notices in the Software and this entire statement, including   #
# the above license grant, this restriction and the following disclaimer,      #
# must be included in all copies of the Software, in whole or in part, and     #
# all derivative works of the Software, unless such copies or derivative       #
# works are solely in the form of machine-executable object code generated by  #
# a source language processor.                                                 #
#                                                                              #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   #
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     #
# FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT    #
# SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE    #
# FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,  #
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER  #
# DEALINGS IN THE SOFTWARE.                                                    #
#==============================================================================#

class_name ScriptMachine extends Node
func get_class() -> String: return "ScriptMachine"
static func get_instance_base_type() -> StringName: return "ScriptMachine"

const SCRIPT_PATH       : String              = "user://scripts/"

# signal for selectively updating more frequently (scripts subscribe themselves)
signal update_cycle

# game objects that operate logic externally to the scene tree
@onready var entities   : Array[EntityScript]

# scripts that operate similar to autoload scripts for running independant co-routines
@onready var agents     : Dictionary          = {}

# scripts that contain functions or variables but do not automatically operate logic
@onready var utilities  : Dictionary          = {}

func _ready() -> void:
	# generate source and binary folders
	for path in ["agent/_", "entity/_", "utility/"]:
		var dir : String = SCRIPT_PATH + path
		if not DirAccess.dir_exists_absolute(dir):
			DirAccess.make_dir_recursive_absolute(dir)
	
	# preload agents and utility scripts
	load_scripts_recursively(load_utility, "utility")
	load_scripts_recursively(load_agent, "agent")

func _process(delta) -> void:
	# process all agent functions
	for agent in agents.values():
			agent._process(delta)
	
	# process all self-hooked entity immediate cycle update functions
	update_cycle.emit(delta)

func _physics_process(delta) -> void:
	# recursive _physics_process call to agents
	for agent in agents.values():
		agent._physics_process(delta)
	
	# recursive _physics_process call to entities
	for entity in entities:
		entity._update(delta)

# will prevent crashing at first level of template extension
func detect_extend_fail(code: String, path: String) -> bool:
	if not code.contains("extends \""): return false
	
	var ext_offset := code.find("extends \"")
	var start_path := code.find("\"", ext_offset) + 1
	var end_path   := code.find("\"", start_path)
	var test_path  := "/" + code.substr(start_path, end_path - start_path)
	
	# extension class not found!
	if not FileAccess.file_exists(path.get_base_dir() + test_path):
		push_error("Extended class not found!(" + test_path + "): [" + path + "]")
		return true
	
	return false

func load_scripts_recursively(load_func: Callable, path: String) -> void:
	# cache the usable path
	var cd  := SCRIPT_PATH + path + "/"
	
	# safety check
	if not DirAccess.dir_exists_absolute(cd):
		DirAccess.make_dir_recursive_absolute(cd)
		return
	
	var files     := DirAccess.get_files_at(cd)
	var base_path := path.get_slice("/", 0)
	for file in files:
		# ensure it is a script file
		if file.get_extension() != "gd": continue
		
		# skip files starting with _ for templates
		if file.begins_with("_"): continue
		
		load_func.call(path.substr(base_path.length() + 1) + "/" + file)
	
	# process sub-directory script loading
	var sub_dirs := DirAccess.get_directories_at(cd)
	for sub_dir in sub_dirs:
		# skip folders starting with _ for templates
		if sub_dir.begins_with("_"): continue
		
		load_scripts_recursively(load_func, path + "/" + sub_dir)

func load_script(path: String) -> Script:
	# path setup
	if not path.begins_with(SCRIPT_PATH):
		path = SCRIPT_PATH + path
	if path.get_extension() != "gd":
		path = path.get_basename() + ".gd"
	
	# check if source exists
	if not FileAccess.file_exists(path):
		push_error("Script file not found: [" + path + "]")
		return null
	
	# temporarily build the script
	var script := GDScript.new()
	var code   := FileAccess.get_file_as_string(path)
	
	# exit if extending failed
	if detect_extend_fail(code, path): return null
	
	script.resource_path = path
	script.source_code   = code
	var err := script.reload()
	if err != OK:
		push_error("Error Code (" + str(err) + "): [" + path + "]")
		return null
	
	return script

func save_script(code: String, path: String) -> bool:
	# exit if extending failed
	if detect_extend_fail(code, path): return false
	
	# temporarily build the script
	var script : = GDScript.new()
	script.resource_path = path
	script.source_code = code
	var err := script.reload()
	
	# report error and escape if failed
	if err != OK:
		push_error("Error Code (" + str(err) + "): [" + path + "]")
		return false
	
	# path setup
	if not path.begins_with(SCRIPT_PATH):
		path = SCRIPT_PATH + path
	if path.get_extension() != "gd":
		path = path.get_basename() + ".gd"
	
	# ensure source directory exists
	var dir = path.get_base_dir()
	if not DirAccess.dir_exists_absolute(dir):
		DirAccess.make_dir_recursive_absolute(dir)
	
	# save the source file
	err = ResourceSaver.save(script, path)
	if err != OK:
		push_error("Error Code (" + str(err) + "): [" + path + "]")
		return false
	
	return true

func load_agent(path: String) -> void:
	var file_path := "agent/" + path
	
	# attempt to grab scripts
	var script : Script = load_script(file_path)
	if not script: return
	
	# generate instance of script
	var inst : AgentScript = script.new(self) as AgentScript
	if not inst: return
	
	# integrate it to our global scripts
	var file_name : String = path.get_basename().replace("/", "_").to_lower()
	agents[file_name] = inst
	inst._ready()

func load_entity(path: String) -> void:
	var file_path := "entity/" + path
	
	# attempt to grab scripts
	var script : Script = load_script(file_path)
	if not script: return
	
	# generate instance of script
	var inst : EntityScript = script.new(self) as EntityScript
	if not inst: return
	
	# add an anonymous instance
	entities.append(inst)
	inst._create()

func load_utility(path: String) -> void:
	var file_path := "utility/" + path
	
	# attempt to grab scripts
	var script : Script = load_script(file_path)
	if not script: return
	
	# generate instance of script
	var inst : RefCounted = script.new()
	if not inst: return
	
	# integrate it to our global scripts
	var file_name : String = path.get_basename().replace("/", "_").to_lower()
	utilities[file_name] = inst

func get_agent(agent: String) -> AgentScript:
	if not agents.has(agent): return null
	return agents[agent]

func get_utility(utility: String) -> RefCounted:
	if not utilities.has(utility): return null
	return utilities[utility]

func dispose_entity(entity: EntityScript) -> void:
	if not entities.has(entity): return
	entity._on_destroy()
	entities.erase(entity)
